debug_puts "inside notebook_api.rb -- about to require notebook_events.rb "
require "notebook_events.rb"
debug_puts "inside notebook_api.rb -- about to require notebook_animation.rb "
require "notebook_animation.rb"
debug_puts "inside notebook_api.rb -- continuing with notebook_api.rb "

#Maybe put in namespace
def fly_annotation
  fly = Document.current.selected_annotation
  fly = Document.current.first_annotation if fly.nil?
  
  if fly.nil?
	  App.alert "The page is empty"
	  return	
  end

  start_pos = fly.position
  (1..100).each do |i|
	  fly.position = [start_pos.x + i * 5, start_pos.y + Math.sin((i / 20.0 * 3.14)) * 50 + 50]
	  Document.current.draw! if (i%2 == 0)
    #puts start_pos.x.to_s
  end
  
  # Reset..
  fly.position = start_pos
end

class Globals
  @stop_flying = false
  def Globals.should_stop_flying?
    @stop_flying
  end
  
  def Globals.start_flying
    @stop_flying = false
  end
  
  def Globals.stop_flying
    @stop_flying = true
  end
  
  def fps
    30
  end
  
  def spf
    0.03333 #1/fps
  end
end

def fly_forever
  Globals.start_flying
  
  annotation = Document.current.selected_annotation
  
  if annotation.nil?
	  App.alert "No annotations selected"
	  return
  end
  
  fly_forever_animation annotation

end

def fly_forever_animation (annotation)
  linear_animation do |counter|
    	counter += 1
    	deltax = 4
    	deltax = -4 if (counter % 101) > 50
    	deltay = Math.sin(counter / 20.0 * 3.14) * 10
    	p = annotation.position
    	annotation.position = [p.x + deltax, p.y + deltay]
  end
end

def current_annotation
  annotation = Document.current.selected_annotation
  
  if annotation.nil?
	  App.alert "No annotations selected"
	  return
  end
  
  starting_position = annotation.position
  
  yield annotation
  
  #annotation.position = starting_position
  #annotation.transparency = 1.0
end

def fade_in_and_out
    current_annotation do |annotation|
      linear_animation do |counter|
        annotation.transparency = Math.sin(counter / 10.0).abs
      end
    end
end

def slide_from_side
  current_annotation do |annotation|
    slide_from_side_animation(annotation)
  end
end

def animate_along_points (annotation, points)
  starting_position = [annotation.position.x, annotation.position.y]
  linear_animation do |counter|
    if counter >= points.size
        annotation.position = starting_position
        return false
    end
    new_position = points[counter % points.size]
    new_position.x -= annotation.size.width / 2.0
    new_position.y -= annotation.size.height / 2.0
    annotation.position = new_position
  end
end

def shrink_and_grow
  current_annotation do |annotation|
    shrink_and_grow_animation annotation
  end
end

def spin
  current_annotation do |a|
    spin_animation(a)
  end
end

def start_redraw_timer
  #puts "Starting timer.."
  Globals.start_flying
  #return if not Globals.should_stop_flying?
  
  document = Document.current
  Thread.new do
    loop do
      document.draw
      sleep 0.05
    	break if Globals.should_stop_flying?
    end
  end
end

def silly_arrow (args)
	a = args[:annotation]
	x = args[:x] + 0.0
	y = args[:y] + 0.0
	
	return if x.abs > 10 or y.abs > 10

	sign = 1
	sign = -1 if x < 0
	x = 0.0001 * sign if x < 0.0001 and x > -0.0001

	angle = Math.atan(y / x) / 3.14159 * 180
	#puts "#{x}, #{y}, #{angle}"
	
	angle += 180 if x < 0
	
	a.rotation = angle + 90 #for default arrow
end

#Event.add_observer(:annotation_moved, :silly_arrow)

if false
  App.add_menu "Start Redraw Timer", "start_redraw_timer"

  App.add_menu "Fly", "fly_annotation"
  App.add_menu "Fly Forever", "fly_forever"
  App.add_menu "Slide in from side", "slide_from_side"
  App.add_menu "Fade in and out", "fade_in_and_out"
  App.add_menu "Oscillate width", "shrink_and_grow"
  App.add_menu "Spin annotation", "spin"
  App.add_menu "Stop Threads", "Globals.stop_flying"
end
#start_redraw_timer()

#puts "Loaded Notebook API"
