require "singleton"

#Some methods for "Point", mixin better?  or just make a .point that returns a point?
class Array

	def x= newX
		self[0] = newX
	end
	
	def y= newY
		self[1] = newY
	end
	
	def x
		self[0]
	end
	
	def y
		self[1]
	end

  def width= newW
    self[0] = newW
  end
  
  def height= newH
    self[1] = newH
  end
  
  def width
    self[0]
  end
  
  def height
    self[1]
  end
  
end

class Point < Array
  def - (p)
    return Point[self.x - p.x, self.y - p.y]
  end
  
  def + (p)
    return Point[self.x + p.x, self.y + p.y]
  end

  def * (n)
    return Point[self.x * n, self.y * n]
  end
  
  def / (n)
    return Point[self.x / n, self.y / n]
  end
end

class Size < Array
end

class PointProxy
	def initialize(ann, point)
		@point = point
		@ann = ann
	end

	def x 
		@point.x
	end

	def y
		@point.y
	end

	def x= (newX)
		@point.x = newX
		@ann.position = @point
	end
	
	def y= (newY)
		@point.y = newY
		@ann.position = @point
	end	  
end

class SizeProxy
	def initialize(ann, size)
		@size = size
		@ann = ann
	end

	def width 
		@size.width
	end

	def height
		@size.height
	end

	def width= (newW)
		@size.width = newW
		@ann.size = @size
	end
	
	def height= (newH)
		@size.height = newH
		@ann.size = @size
	end
end

#class Point < Array
#	
#	def initialize(x = -1.0, y = -1.0)
#		self << x << y;
#	end
#
#	def x= newX
#		self[0] = newX
#	end
#	
#	def y= newY
#		self[1] = newY
#	end
#	
#	def x
#		self[0]
#	end
#	
#	def y
#		self[1]
#	end
#	
#	def to_s
#		"[#{@x}, #{@y}]"
#	end
#end

class Rect
	attr_accessor :origin, :size
	def initialize
		@origin = Point.new
		@size = Size.new
	end
	def to_s
		"(#{@origin}#{@size})"
	end
end

class NotebookObject
	@c_address = nil
	def initialize(address = nil)
		@c_address = address
	end
	attr_accessor :c_address
end

# for sandboxing user scripts
def sandbox_do(safe_level)
	(Thread.new {$SAFE = safe_level ; yield } ).value
end

#irb(main):001:0> class Point; def x; 10; end; end
#=> nil
#irb(main):002:0> p = Point.new
#=> #<Point:0x1c6b60>
#irb(main):003:0> local_var = "foo!"
#=> "foo!"
#irb(main):004:0> class << p; self; end.class_eval do
#irb(main):005:1*  alias :old_x :x
#irb(main):006:1>  define_method(:x) { puts local_var; old_x() }
#irb(main):007:1> end
#=> #<Proc:0x0033ef58@(irb):6>
#irb(main):008:0> p.x
#foo!
#=> 10

#def debug_puts(str)
#end
